# Purpose: Parameter file for all functions
# Author: Yali Chen
# Aug, 2016
###############################################################################
# Reference
###############################################################################
# Meta programming: http://stackoverflow.com/questions/15790743/data-table-meta-programming

#rm(list = ls(all = TRUE))
#options(run.main=TRUE)

################################################################################
############################ Utility Functions #################################
################################################################################
{
  
  # Function that checks if package is installed.
  # If installed, it loads it. If it isn't, it installs it.
  pkgTest <- function(x) {
    if (!(x %in% installed.packages()[, 'Package'])) {
      tryCatch({
        message(paste0('INSTALLING PACKAGE ',toupper(x)))
        if (x == 'xda') {
          install_github("ujjwalkarn/xda")
        } else if (x == 'anesrake') {
          install.packages("E:/R Package/anesrake_0.75.tar.gz", repos = NULL, type = "source")
        } else {
          install.packages(x, quiet = TRUE)
        }
      }, error = function(e) {
        stop(paste0('  ERROR: ',e))
      })
    } 
    message(paste0('LOADING PACKAGE ',toupper(x)))
    library(x,character.only = TRUE, quietly = TRUE)
  }
  
  # Function to format list to write to file
  write_list <- function(prefix,list,indent,total_length) {
    llist <- length(list)
    cond <- 1
    count <- 1
    while (cond) {
      ltoprint <- paste(list[1:count],collapse=', ')
      line <- paste(prefix,ltoprint)
      lline <- nchar(line)
      if (lline < total_length) {
        if (count < llist) {
          count <- count+1
        } else {
          cond <- 0
        }
      } else {
        cond <- 0
        count <- count-1
        if (count < 1) {
          line <- prefix
        } else {
          ltoprint <- paste(list[1:count],collapse=', ')
          line <- paste(prefix,ltoprint)
        }
      }
    }
    message(line)
    
    prefix <- paste(rep(" ",indent),collapse="")
    
    while (count < llist) {
      cond <- 1
      count <- count+1
      count2 <- count
      while (cond) {
        ltoprint <- paste(list[count2:count],collapse=', ')
        line <- paste0(prefix,ltoprint)
        lline <- nchar(line)
        if (lline < total_length) {
          if (count < llist) {
            count <- count+1
          } else {
            cond <- 0
          }
        } else {
          cond <- 0
          count <- count-1
          if (count < count2) {
            count <- count+1
          } else {
            ltoprint <- paste(list[count2:count],collapse=', ')
            line <- paste0(prefix,ltoprint)
          }
        }
      }
      message(line)
    }
  }
  
  # Get index of columns in a dataset
  get_indexes <- function(columns,dataset) {
    columns <- tolower(columns)
    indexes <- c()
    for (colname in columns) {
      indexes <- c(indexes,match(colname,tolower(names(dataset))))
    }
    return(indexes)
  }
  
  # This function returns TRUE wherever elements are different, including NA's,
  # and FALSE everywhere else.
  compareNA <- function(v1,v2) {
    same <- (v1 == v2) | (is.na(v1) & is.na(v2))
    same[is.na(same)] <- FALSE
    return(!same)
  }
  
  # Function to compare two data.table objects and write differences to file
  validate_dt_file <- function(Modelfile,Comparisonfile,key_column,outname,
                               dump_diff_file) {
    
    # First test: Check that both files have the same number of columns and rows
    
    ncolSAS <- base::ncol(Modelfile)
    nrowSAS <- base::nrow(Modelfile)
    ncolCSV <- base::ncol(Comparisonfile)
    nrowCSV <- base::nrow(Comparisonfile)
    
    if ((ncolSAS == ncolCSV) && (nrowSAS == nrowCSV)) { 
      
      # Second test: Check that columns in both files have the same names
      #              (case can be different (uppercase vs. lowercase) and order
      #               of the columns can be different, but names have to be the same)
      
      SAScolnames <- base::sort(base::tolower(base::colnames(Modelfile)))
      CSVcolnames <- base::sort(base::tolower(base::colnames(Comparisonfile)))
      ndiff <- 0
      for (icol in 1:base::length(SAScolnames)) {
        if (SAScolnames[icol] != CSVcolnames[icol]) { ndiff <- ndiff+1 }
      }
      
      if (ndiff == 0) {
        
        # Third test: Compare files column-by-column
        
        # Rearrange Rfile columns to be in the same order as Modelfile
        base::names(Modelfile) <- base::tolower(base::names(Modelfile))
        base::names(Comparisonfile) <- base::tolower(base::names(Comparisonfile))
        if (ncolSAS > 1) {
          Comparisonfile <- Comparisonfile[,names(Modelfile),with=F]
        }
        
        # Sort datasets according to key_column to have rows in the same order
        indexes <- get_indexes(key_column,Modelfile)
        key_names <- base::names(Modelfile)[indexes]
        if (nrowSAS > 1) {
          Modelfile <- setorderv(Modelfile,key_names)
          Comparisonfile <- setorderv(Comparisonfile,key_names)
        }
        
        # Use "compare" function to validate each column in the file against its 
        # SAS counterpart
        count <- 0
        for (i in 1:ncolSAS) {
          #i=6
          comparison <- compare::compare(Modelfile[[i]], Comparisonfile[[i]]
                                         ,equal = TRUE
                                         ,coerce = TRUE
                                         #,shorten = TRUE
                                         #,ignoreOrder = TRUE
                                         #,ignoreNameCase = TRUE
                                         #,ignoreNames = TRUE
                                         ,ignoreAttrs = TRUE
                                         ,round = TRUE
                                         #,ignoreCase = TRUE
                                         #,trim = TRUE
                                         #,dropLevels = TRUE
                                         #,ignoreLevelOrder = TRUE
                                         #,ignoreDimOrder = TRUE
                                         #,ignoreColOrder = TRUE
                                         #,ignoreComponentOrder = TRUE
                                         #,colsOnly = TRUE
                                         #,allowAll = TRUE
          )
          
          # If discrepancies are found, write discrepancies to file for evaluation
          # by the user
          if (!comparison$result) {
            count <- count+1
            base::message(paste0('  - Found discrepancies in column: ',
                                 base::names(Modelfile)[i]))
            if (dump_diff_file) {
              SAS_np <- Modelfile[compareNA(comparison$tM[], comparison$tC[]),c(indexes,i),with=F]
              
              CSV_np <- Comparisonfile[compareNA(comparison$tM[], comparison$tC[]),c(indexes,i),with=F]
              
              base::names(SAS_np) <- base::paste0('Model_',base::names(SAS_np))
              base::names(CSV_np) <- base::paste0('Comparison_',base::names(CSV_np))
              for (j in 1:base::length(key_names)) {
                base::names(CSV_np)[base::names(CSV_np) == base::paste0('Comparison_',key_names[j])] <- key_names[j]
                base::names(SAS_np)[base::names(SAS_np) == base::paste0('Model_',key_names[j])] <- key_names[j]
              }
              
              diff <- base::merge(SAS_np, CSV_np, by=key_names, all=TRUE)
              base::message(paste0('    ',nrow(diff),' discrepancies found.'))
              model_name <- paste0('Model_',names(Modelfile)[i])
              comparison_name <- paste0('Comparison_',names(Modelfile)[i])
              if (class(diff[[model_name]]) == 'numeric') {
                diff$`%Diff` <- round((diff[,comparison_name,with=F]-diff[,model_name,with=F])/
                                        diff[,model_name,with=F]*100,0)
              }
              
              if (count == 1) {
                xlsx::write.xlsx(diff,paste0(outname,'.xlsx'),row.names=FALSE
                                 ,sheetName = base::names(Modelfile)[i])
              } else {
                xlsx::write.xlsx(diff,paste0(outname,'.xlsx'),row.names=FALSE
                                 ,sheetName = base::names(Modelfile)[i],append = TRUE)
              }
              
              jgc()
            }
          }
        }
        
        if (count == 0) {
          base::message('  - No discrepancies were found.')
        } else {
          if (dump_diff_file) {
            base::message(paste0('  - Report saved in ',outname,'.xlsx'))
            # Sys.setenv(RSTUDIO_PANDOC="C:/Program Files/RStudio/bin/pandoc")
            # render(paste0(params$code_loc,"/gen_val_report.Rmd"),#'all',
            #        output_file = paste0(outname,'.html'),
            #        params = list(path = params$path, outname = outname),
            #        quiet = T)
          }
        }
        
        
      } else {
        
        base::message('  - Discrepancies were found.')
        base::message('    Column names in model and comparison datasets do not match.')
        write_list('    Column names in model dataset are:', SAScolnames, 
                   6,80)
        write_list('    Column names in comparison dataset are:', CSVcolnames, 
                   6,80)
        
      }
      
    } else {
      
      base::message('  - Discrepancies were found.')
      base::message(base::paste0('    The model dataset has ',base::toString(nrowSAS)
                                 ,' rows and ',base::toString(ncolSAS),' columns.'))
      base::message(base::paste0('    while the comparison dataset has ',base::toString(nrowCSV)
                                 ,' rows and ',base::toString(ncolCSV),' columns.'))
    }
    
  }
  
  # Function to compare two ffdf datasets and write differences to file
  validate_ff_file <- function(Modelfile,Comparisonfile,key_column,outname,
                               dump_diff_file) {
    
    # First test: Check that both files have the same number of columns and rows
    
    if (is.null(ff::length.ffdf(Modelfile))) { 
      ncolSAS <- 1 
      nrowSAS <- base::length(Modelfile[,1])
    } else {
      ncolSAS <- base::ncol(Modelfile)
      nrowSAS <- base::nrow(Modelfile)
    }
    
    if (is.null(ff::length.ffdf(Comparisonfile))) { 
      ncolCSV <- 1 
      nrowCSV <- base::length(Comparisonfile[,1])
    } else {
      ncolCSV <- base::ncol(Comparisonfile)
      nrowCSV <- base::nrow(Comparisonfile)
    }
    
    if ((ncolSAS == ncolCSV) && (nrowSAS == nrowCSV)) { 
      
      # Second test: Check that columns in both files have the same names
      #              (case can be different (uppercase vs. lowercase) and order
      #               of the columns can be different, but names have to be the same)
      
      SAScolnames <- base::sort(base::tolower(base::colnames(Modelfile)))
      CSVcolnames <- base::sort(base::tolower(base::colnames(Comparisonfile)))
      ndiff <- 0
      for (icol in 1:base::length(SAScolnames)) {
        if (SAScolnames[icol] != CSVcolnames[icol]) { ndiff <- ndiff+1 }
      }
      
      if (ndiff == 0) {
        
        # Third test: Compare files column-by-column
        
        # Rearrange Rfile columns to be in the same order as Modelfile
        base::names(Modelfile) <- base::tolower(base::names(Modelfile))
        base::names(Comparisonfile) <- base::tolower(base::names(Comparisonfile))
        if (ncolSAS == 1) {
          base::names(Comparisonfile) <- base::names(Modelfile)
        } else if (nrowSAS == 1) {
          Comparisonfile <- ff::as.ffdf(base::as.data.frame(Comparisonfile[,base::names(Modelfile)]))
        } else {
          Comparisonfile <- Comparisonfile[names(Modelfile)]
          #Comparisonfile <- ff::as.ffdf(Comparisonfile[,base::names(Modelfile)])
        }
        
        # Sort datasets according to key_column to have rows in the same order
        indexes <- get_indexes(key_column,Modelfile)
        key_names <- base::names(Modelfile)[indexes]
        if (nrowSAS > 1) {
          Modelfile <- Modelfile[ff::ffdforder(Modelfile[indexes]), ]
          Comparisonfile <- Comparisonfile[ff::ffdforder(Comparisonfile[indexes]), ]
        }
        
        # Use "compare" function to validate each column in the file against its 
        # SAS counterpart
        count <- 0
        for (i in 1:ncolSAS) {
          #i=16
          comparison <- compare::compare(Modelfile[,i], Comparisonfile[,i]
                                         ,equal = TRUE
                                         ,coerce = TRUE
                                         #,shorten = TRUE
                                         #,ignoreOrder = TRUE
                                         #,ignoreNameCase = TRUE
                                         #,ignoreNames = TRUE
                                         ,ignoreAttrs = TRUE
                                         ,round = TRUE
                                         #,ignoreCase = TRUE
                                         #,trim = TRUE
                                         #,dropLevels = TRUE
                                         #,ignoreLevelOrder = TRUE
                                         #,ignoreDimOrder = TRUE
                                         #,ignoreColOrder = TRUE
                                         #,ignoreComponentOrder = TRUE
                                         #,colsOnly = TRUE
                                         #,allowAll = TRUE
          )
          
          # If discrepancies are found, write discrepancies to file for evaluation
          # by the user
          if (!comparison$result) {
            count <- count+1
            base::message(paste0('    Found discrepancies in column: ',
                                 base::names(Modelfile)[i]))
            if (dump_diff_file) {
              SAS_np <- base::as.data.frame(Modelfile[compareNA(comparison$tM[], comparison$tC[]),c(indexes,i)])
              # SAS_np <- base::as.data.frame(Modelfile[base::which((comparison$tM[] != comparison$tC[]) |
              #                                                    !(is.na(comparison$tM[]) & is.na(comparison$tC[]))) 
              #                                         ,c(indexes,i)])
              
              CSV_np <- base::as.data.frame(Comparisonfile[compareNA(comparison$tM[], comparison$tC[]),c(indexes,i)])
              # CSV_np <- base::as.data.frame(Comparisonfile[base::which((comparison$tM[] != comparison$tC[]) |
              #                                                         !(is.na(comparison$tM[]) & is.na(comparison$tC[])))
              #                                              ,c(indexes,i)])
              # if ((base::nrow(SAS_np) == 0) || (base::nrow(CSV_np) == 0)) {
              #   SAS_np <- Modelfile[,c(indexes,i)]
              #   CSV_np <- Comparisonfile[,c(indexes,i)]
              # }
              
              base::names(SAS_np) <- base::paste0('Model_',base::names(SAS_np))
              base::names(CSV_np) <- base::paste0('Comparison_',base::names(CSV_np))
              for (j in 1:base::length(key_names)) {
                base::names(CSV_np)[base::names(CSV_np) == base::paste0('Comparison_',key_names[j])] <- key_names[j]
                base::names(SAS_np)[base::names(SAS_np) == base::paste0('Model_',key_names[j])] <- key_names[j]
              }
              
              diff <- base::merge(SAS_np, CSV_np, on=key_names, all=TRUE)
              model_name <- paste0('Model_',names(Modelfile)[i])
              comparison_name <- paste0('Comparison_',names(Modelfile)[i])
              if (class(diff[,model_name]) == 'numeric') {
                diff$`%Diff` <- round((diff[,comparison_name]-diff[,model_name])/
                                      diff[,model_name]*100,0)
              }
              
              if (count == 1) {
                xlsx::write.xlsx(diff,outname,row.names=FALSE
                                 ,sheetName = base::names(Modelfile)[i])
              } else {
                xlsx::write.xlsx(diff,outname,row.names=FALSE
                                 ,sheetName = base::names(Modelfile)[i],append = TRUE)
              }
              
              jgc()
            }
          }
        }
        
        if (count == 0) {
          base::message('    No discrepancies were found.')
        } else {
          if (dump_diff_file) {
            base::message(paste0('    Report saved in ',outname))
          }
        }
        
        
      } else {
        
        base::message('    Discrepancies were found.')
        base::message('      Column names in model and comparison datasets do not match.')
        write_list('        Column names in model dataset are:', SAScolnames, 
                   8,80)
        write_list('        Column names in comparison dataset are:', CSVcolnames, 
                   8,80)
        
      }
      
    } else {
      
      base::message('    Discrepancies were found.')
      base::message(base::paste0('      The model dataset has ',base::toString(nrowSAS)
                                 ,' rows and ',base::toString(ncolSAS),' columns.'))
      base::message(base::paste0('      while the comparison dataset has ',base::toString(nrowCSV)
                                 ,' rows and ',base::toString(ncolCSV),' columns.'))
    }
    
  }
  
  # Function to compare two datasets and write differences to file
  validate_ff_file_old <- function(Modelfile,Comparisonfile,key_column,outname,
                               dump_diff_file) {
    
    # First test: Check that both files have the same number of columns and rows
    
    if (is.null(ff::length.ffdf(Modelfile))) { 
      ncolSAS <- 1 
      nrowSAS <- base::length(Modelfile[,1])
    } else {
      ncolSAS <- base::ncol(Modelfile)
      nrowSAS <- base::nrow(Modelfile)
    }
    
    if (is.null(ff::length.ffdf(Comparisonfile))) { 
      ncolCSV <- 1 
      nrowCSV <- base::length(Comparisonfile[,1])
    } else {
      ncolCSV <- base::ncol(Comparisonfile)
      nrowCSV <- base::nrow(Comparisonfile)
    }
    
    if ((ncolSAS == ncolCSV) && (nrowSAS == nrowCSV)) { 
      
      # Second test: Check that columns in both files have the same names
      #              (case can be different (uppercase vs. lowercase) and order
      #               of the columns can be different, but names have to be the same)
      
      SAScolnames <- base::sort(base::tolower(base::colnames(Modelfile)))
      CSVcolnames <- base::sort(base::tolower(base::colnames(Comparisonfile)))
      ndiff <- 0
      for (icol in 1:base::length(SAScolnames)) {
        if (SAScolnames[icol] != CSVcolnames[icol]) { ndiff <- ndiff+1 }
      }
      
      if (ndiff == 0) {
        
        # Third test: Compare files column-by-column
        
        # Rearrange Rfile columns to be in the same order as Modelfile
        base::names(Modelfile) <- base::tolower(base::names(Modelfile))
        base::names(Comparisonfile) <- base::tolower(base::names(Comparisonfile))
        if (ncolSAS == 1) {
          base::names(Comparisonfile) <- base::names(Modelfile)
        } else if (nrowSAS == 1) {
          Comparisonfile <- ff::as.ffdf(base::as.data.frame(Comparisonfile[,base::names(Modelfile)]))
        } else {
          Comparisonfile <- ff::as.ffdf(Comparisonfile[,base::names(Modelfile)])
        }
        
        # Sort datasets according to key_column to have rows in the same order
        indexes <- get_indexes(key_column,Modelfile)
        key_names <- base::names(Modelfile)[indexes]
        if (nrowSAS > 1) {
          Modelfile <- Modelfile[ff::ffdforder(Modelfile[indexes]), ]
          Comparisonfile <- Comparisonfile[ff::ffdforder(Comparisonfile[indexes]), ]
        }
        
        # Use "compare" function to validate each column in the file against its 
        # SAS counterpart
        count <- 0
        for (i in 1:ncolSAS) {
          comparison <- compare::compare(Modelfile[,i], Comparisonfile[,i]
                                         ,equal = TRUE
                                         ,coerce = TRUE
                                         #,shorten = TRUE
                                         #,ignoreOrder = TRUE
                                         #,ignoreNameCase = TRUE
                                         #,ignoreNames = TRUE
                                         ,ignoreAttrs = TRUE
                                         ,round = TRUE
                                         #,ignoreCase = TRUE
                                         #,trim = TRUE
                                         #,dropLevels = TRUE
                                         #,ignoreLevelOrder = TRUE
                                         #,ignoreDimOrder = TRUE
                                         #,ignoreColOrder = TRUE
                                         #,ignoreComponentOrder = TRUE
                                         #,colsOnly = TRUE
                                         #,allowAll = TRUE
          )
          
          # If discrepancies are found, write discrepancies to file for evaluation
          # by the user
          if (!comparison$result) {
            count <- count+1
            base::message(paste0('    Found discrepancies in column: ',
                                 base::names(Modelfile)[i]))
            if (dump_diff_file) {
              SAS_np <- base::as.data.frame(Modelfile[base::which(comparison$tM[] != comparison$tC[])
                                                      ,c(indexes,i)])
              CSV_np <- base::as.data.frame(Comparisonfile[base::which(comparison$tM[] != comparison$tC[])
                                                           ,c(indexes,i)])
              if ((base::nrow(SAS_np) == 0) || (base::nrow(CSV_np) == 0)) {
                SAS_np <- Modelfile[,c(indexes,i)]
                CSV_np <- Comparisonfile[,c(indexes,i)]
              }
              
              base::names(SAS_np) <- base::paste0('Model_',base::names(SAS_np))
              base::names(CSV_np) <- base::paste0('Comparison_',base::names(CSV_np))
              for (j in 1:base::length(key_names)) {
                base::names(CSV_np)[base::names(CSV_np) == base::paste0('Comparison_',key_names[j])] <- key_names[j]
                base::names(SAS_np)[base::names(SAS_np) == base::paste0('Model_',key_names[j])] <- key_names[j]
              }
              
              diff <- base::merge(SAS_np, CSV_np, on=key_names, all=TRUE)
              
              if (count == 1) {
                xlsx::write.xlsx(diff,outname,row.names=FALSE
                                 ,sheetName = base::names(Modelfile)[i])
              } else {
                xlsx::write.xlsx(diff,outname,row.names=FALSE
                                 ,sheetName = base::names(Modelfile)[i],append = TRUE)
              }
              
              jgc()
            }
          }
        }
        
        if (count == 0) {
          base::message('    No discrepancies were found.')
        } else {
          if (dump_diff_file) {
            base::message(paste0('    Report saved in ',outname))
          }
        }
        
        
      } else {
        
        base::message('    Discrepancies were found.')
        base::message('      Column names in model and comparison datasets do not match.')
        write_list('        Column names in model dataset are:', SAScolnames, 
                   8,80)
        write_list('        Column names in comparison dataset are:', CSVcolnames, 
                   8,80)
        
      }
      
    } else {
      
      base::message('    Discrepancies were found.')
      base::message(base::paste0('      The model dataset has ',base::toString(nrowSAS)
                                 ,' rows and ',base::toString(ncolSAS),' columns.'))
      base::message(base::paste0('      while the comparison dataset has ',base::toString(nrowCSV)
                                 ,' rows and ',base::toString(ncolCSV),' columns.'))
    }
    
  }
  
  # Function to collect Java garbage when using xlsx package
  jgc <- function() {
    base::gc()
    .jcall("java/lang/System", method = "gc")
  }
  
  # Function to load and rename RData file, and allocate memory to it
  loadRData <- function(fileName,colalloc){
    #loads an RData file, and returns it
    load(fileName)
    alloc.col(get(ls()[ls() != "fileName"]),colalloc)
  }
  
  # Function to load and rename RData file
  loadRData_noalloc <- function(fileName) {
    #loads an RData file, and returns it
    load(fileName)
    get(ls()[ls() != "fileName"])
  }
  
  # Function to create list of metrics
  CreateMetricsList <- function(segmentlst,metrics,period.def) {
    if (is.null(period.def) == FALSE) {
      outputlist <- vector(mode="list"
                           , length = length(segmentlst) * length(metrics) * length(period.def))
      
      i <- 1
      for (x in seq_along(segmentlst)){
        for (y in seq_along(metrics)){
          for (z in seq_along(period.def)){
            outputlist[i] <- lapply(
              period.def[z]
              ,function(m) paste(segmentlst[x],metrics[y],m,sep="_"))
            i<- i + 1
          }
        }
      }
      return(outputlist)
    }
    
    else if (is.null(period.def) == TRUE){
      outputlist <- vector(mode="list"
                           , length= length(segmentlst) * length(metrics))
      
      i <- 1
      for (x in seq_along(segmentlst)){
        for (y in seq_along(metrics)){
          outputlist[i] <- paste(segmentlst[x],metrics[y],sep="_")
          i<- i + 1
        }
      }
      return(outputlist)
    }
    
  }
  
}
################################################################################
########################### Packages to Import #################################
################################################################################
{
    pkgTest('data.table')
    pkgTest('matrixStats')
    pkgTest('survey')
    pkgTest('knitr') # For all tables
    pkgTest('grid') # For setting margin in cm
    pkgTest('xtable')
    pkgTest('devtools')
    pkgTest('xda')
    pkgTest('Hmisc')
    pkgTest('jsonlite')
    pkgTest('haven')
    options(java.parameters = "-Xmx16000m")
    pkgTest('rJava')
    pkgTest('xlsx')
    pkgTest('compare')
    pkgTest('rmarkdown')
    pkgTest('kableExtra')
    pkgTest('plyr')
    pkgTest('parallel')
    pkgTest('rlist')
    pkgTest('weights')
    pkgTest('anesrake')
}
################################################################################
############################# Main Function ####################################
################################################################################
{
  
  main_10 <- function(params) {
    
    options(digits=8)
    
    params$datatype = tolower(params$datatype)
    
    # Create log file
    path <- params$path
    setwd(path)
    code_loc <- params$code_loc
    if (!file.exists(paste0(path,'/log'))) { 
      dir.create(paste0(path,'/log'))
    }
    logfilename = paste0(path,'/log/SE_',strftime(Sys.time()
                                                  ,'%b_%d_%y_%H%M'),'.log')
    log.file <- file(logfilename, open = 'wt')
    sink(log.file, type = "output", append = F)
    sink(log.file, type = "message", append = F)
    
    # Send initial message
    message('##################### STARTING SALES EFFECT ANALYSIS ###########################\n')
    startjob <- Sys.time()
    message(paste0('  Starting at: ', format(startjob, '%d/%b/%y %H:%M:%S')))
    message(paste0('  Location of SE code: ',code_loc))
    message(paste0('  Location of SE data: ',path))
    
    # Create directory for output
    rawfile <- params$rawfile
    outputpath <- paste0(path, "/Output")
    if (!file.exists(outputpath)) { dir.create(outputpath) }
    params$outputpath <- outputpath
    
    datapath <- paste0(path, "/R_Datasets")
    if (!file.exists(datapath)) { dir.create(datapath) }
    params$datapath <- datapath
    
    params$filepath <- paste0(path, "/Data_Argus/", rawfile)
    
    # Only being used for naming purposes
    params$bigseg    = params$segmentlst[1]
    
    params$renstats <- c("spend","trans")
    
    # Create expyes
    params$expyes  = sapply(params$explist,function(x) paste0(x,"yes"))
    
    # Name of datasets for different media types
    proj <- params$proj
    params$data_npm <- paste0(proj,"_npm")
    params$data_ppm <- paste0(proj,"_ppm")
    params$data_neu <- paste0(proj,"_neu") 
    params$data_exp <- paste0(proj,"_exp")
    params$data_mobile <- paste0(proj,"_mobile")
    params$data_print <- paste0(proj,"_print")
    
    # Create expfreq
    explist <- params$explist
    params$expfreq <- sapply(explist,function(x) paste0(x,"freq"))
    
    # List of metrics
    if (!params$financial) {
      params$statslst    <- c("spend","trans","d_per_tr","share")
      statsdeslst <- c("Spending"
                       ,"Transactions"
                       ,"Dollars Per Transactions"
                       ,"Share of Spend")
      if (params$TotalorMonthly == 1) {
        params$statsdeslst <- unlist(lapply(statsdeslst,function(x) paste0(x," (Total)")))
        # params$statsdeslst <- c("Spending (Total)"
        #                         ,"Transactions (Total)"
        #                         ,"Dollars Per Transactions (Total)"
        #                         ,"Share of Spend (Total)")
      } else {
        params$statsdeslst <- unlist(lapply(statsdeslst,function(x) paste0(x," (Monthly)")))
        # params$statsdeslst <- c("Spending (Monthly)"
        #                         ,"Transactions (Monthly)"
        #                         ,"Dollars Per Transactions (Monthly)"
        #                         ,"Share of Spend (Monthly)")
      }
      params$penlist <- "transyes"
    } else {
      params$penlist <- c('cardholder','balyes','carduser','openflag','closeflag')
    }
    
    # Weighting variables (demo vars)
    # Persons level
    params$npmdemos <- c("Gender","age8","county_size","income1","hh_size1"
                        ,"kids_any","education1","hispanic","race_asian","race_black"
                        #,'TV_Hrs_Week_hml','broadband','Number_of_TVs1','paycable','dvr' 
                         )
    
    params$ppmdemos <- c("Gender1", "age8", "income", "hh_size", "kids_any"
                         ,"education2", "race2")
    # expanded tv-expdemos
    params$expdemos <- c("county_size", "HH_Size1", "kids_any", "hispanic"
                         ,"race_asian", "race_cauc")
    # digital-neudemos
    params$neudemos <- c("county_size", "HH_Size1", "kids_any", "hispanic"
                         #,"race_afram"
                         ,"race_asian", "race_cauc")
    # mobile-mobdemos
    params$mobiledemos <- c("county_size", "HH_Size1", "kids_any", "hispanic"
                            #,"race_afram"
                            ,"race_asian", "race_cauc")
    # cross platform-xplatdemos
    params$printdemos <- c("county_size", "HH_Size1", "kids_any", "hispanic"
                           #,"race_afram"
                           ,"race_asian", "race_cauc")
    
    # Rim weighting variable
    params$rimweightvar = paste0("weight_",tolower(params$proj))
    
    # Max exposure frequency 
    params$npmMax <- 400
    params$ppmMax <- 400
    params$neuMax <- 60
    params$expMax <- 400
    params$mobileMax <- 1000
    params$printMax <- 400
    
    # Number of columns to allocate to respondent dataset when loading
    params$colalloc <- 300
    
    write_json(params, file.path(params$path,'params.json'),pretty=TRUE,na='null')
    
    # Run Study
    # Variables and functions to keep
    to_keep <- c('to_keep','params','log.file','startjob','pkgTest','write_list',
                 'get_indexes','compareNA','validate_dt_file','jgc','loadRData',
                 'loadRData_noalloc','CreateMetricsList','argus',
                 'argus_recoded','argus_recoded_wtd')
    # Run data preparation step: 
    # user should prepare this script to (1) read the raw Argus dataset, 
    #                                    (2) create exposure variables and 
    #                                    (3) write as RData file
    if (params$mod_00$run) {
      message(paste0('\n############### Running ',params$path,'/R_Code/00Argus_dataprep... ################\n'))
      source(paste0(params$path,"/R_Code/00Argus_dataprep.R"))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      argus <- main_00(params)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
    }
    if (params$mod_11$run) {
      message('\n########################### Running 11RecodeDemos... ###########################\n')
      source(paste0(params$code_loc,'/11RecodeDemos.R'))
      #source(paste0(params$code_loc,'/11RecodeDemos_ffdf.R'))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      if (!exists('argus')) { 
        message(paste0('\n  Loading ',params$filepath,'.RData'))
        argus <- loadRData(paste0(params$filepath,'.RData'),params$colalloc)
      }
      argus <- main_11(params,argus)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
    }
    if (params$mod_12$run) {
      message('\n######################### Running 12ReadinArgusData... #########################\n')
      source(paste0(params$code_loc,'/12ReadinArgusData.R'))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      if (!exists('argus')) { 
        message(paste0('\n  Loading ',params$datapath,'/argus_11.RData'))
        argus <- loadRData(paste0(params$datapath,'/argus_11.RData'),params$colalloc)
      }
      argus_recoded <- main_12(params,argus)
      rm(argus)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
    }
    if (params$mod_17$run) {
      message('\n####################### Running 17AggregationFunction... #######################\n')
      source(paste0(params$code_loc,"/17AggregationFunction.R"))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      if(params$use_sas_input) {
        if (exists('argus_recoded')) {
          rm(argus_recoded)
          foo <- gc()
        }
        if (params$val_format == 'sas7bdat') {
          message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/argus_',
                         params$datatype,'.sas7bdat'))
          argus_recoded <- as.data.table(haven::read_sas(paste0(params$val_dir,
                           '/SAS_Datasets/argus_',params$datatype,'.sas7bdat')))
        } else if (params$val_format == 'RData') {
          
          if (params$path == 'E:/McDonalds') {
            message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/argus_',
                           params$datatype,'_1.RData'))
            argus_recoded <- loadRData_noalloc(paste0(params$val_dir,
                            '/SAS_Datasets/argus_',params$datatype,'_1.RData'))
          } else {
          
            message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/argus_',
                           params$datatype,'.RData'))
            argus_recoded <- loadRData_noalloc(paste0(params$val_dir,
                             '/SAS_Datasets/argus_',params$datatype,'.RData'))
          }
        }
        names(argus_recoded) <- tolower(names(argus_recoded)) 
      } else if (!exists('argus_recoded')) {
        message(paste0('\n  Loading ',params$datapath,'/argus_12.RData'))
        argus_recoded <- loadRData(paste0(params$datapath,'/argus_12.RData'),
                                   params$colalloc)
      }
      argus_recoded <- main_17(params,argus_recoded)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
    }
    if (params$mod_18$run) {
      message('\n######################### Running 18RemoveOutliers... ##########################\n')
      source(paste0(params$code_loc,"/18RemoveOutliers.R"))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      if(!exists('argus_recoded')) {
        message(paste0('\n  Loading ',params$datapath,'/argus_17.RData'))
        argus_recoded <- loadRData(paste0(params$datapath,'/argus_17.Rdata'),
                                   params$colalloc)
      }
      argus_recoded <- main_18(params,argus_recoded)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
    }
    if (params$mod_19$run) {
      message('\n#################### Running 19BucketExpFreqandSpendPre... #####################\n')
      source(paste0(params$code_loc,"/19BucketExpFreqandSpendPre.R"))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      if(!exists('argus_recoded')) {
        message(paste0('\n  Loading ',params$datapath,'/argus_18.RData'))
        argus_recoded <- loadRData(paste0(params$datapath,"/argus_18.RData"),
                                   params$colalloc)
      }
      argus_recoded <- main_19(params,argus_recoded)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
    }
    if (params$mod_20a$run) {
      message('\n##################### Running 20aPrepWeightingDatasets... ######################\n')
      source(paste0(params$code_loc,"/20aPrepWeightingDatasets.R"))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      if (!exists('argus_recoded')) {
        message(paste0('\n  Loading ',params$datapath,'/argus_19.RData'))
        argus_recoded <- loadRData(paste0(params$datapath,"/argus_19.RData"),
                                   params$colalloc)
      }
      argus_recoded <- main_20a(params,argus_recoded)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
    }
    if (params$mod_20b$run) {
      message('\n################### Running 20bRimWeightingAddNewWeights... ####################\n')
      source(paste0(params$code_loc,"/20bRimWeightingAddNewWeights_NBIrake.R"))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      if (!exists('argus_recoded')) {
        message(paste0('\n  Loading ',params$datapath,'/argus_20a.RData'))
        argus_recoded <- loadRData(paste0(params$datapath,"/argus_20a.RData"),
                                   params$colalloc)
      }
      argus_recoded_wtd <- main_20b(params,argus_recoded)
      rm(argus_recoded)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
      # if (params$mod_20b$val) {
      #   message('\n  Running RimWeightingResultValidation.Rmd')
      #   message(paste0('  - Writing ',params$outputpath,
      #                  '/RimWeightingResultValidation.html'))
      #   Sys.setenv(RSTUDIO_PANDOC="C:/Program Files/RStudio/bin/pandoc")
      #   render(paste0(params$code_loc,"/RimWeightingResultValidation.Rmd"),#'all',
      #          output_dir = params$outputpath,params = list(path = params$path),
      #          quiet = T)
      # }
    }
    if (params$mod_23$run) {
      message('\n#################### Running 23RunAggregationAnalysis... #######################\n')
      source(paste0(params$code_loc,"/23RunAggregationAnalysis.R"))
      #source(paste0(params$code_loc,"/23RunAggregationAnalysis2_nonfinancial_test.R"))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      if(params$use_sas_input) {
        if (params$val_format == 'sas7bdat') {
          message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',
                         tolower(params$bigseg),'_',tolower(params$datatype),'_wtd.sas7bdat'))
          argus_recoded_wtd <- as.data.table(haven::read_sas(paste0(params$val_dir,
                               '/SAS_Datasets/',tolower(params$bigseg),'_',
                               tolower(params$datatype),'_wtd_complete.sas7bdat')))
        } else if (params$val_format == 'RData') {
          if (params$path == 'E:/McDonalds') {
            message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',tolower(params$bigseg),
                           '_',tolower(params$datatype),'_wtd_complete.RData'))
            argus_recoded_wtd <- loadRData_noalloc(paste0(params$val_dir,'/SAS_Datasets/',
                                                          tolower(params$bigseg),'_',
                                                          tolower(params$datatype),
                                                          '_wtd_complete.RData'))
          } else {
            message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',tolower(params$bigseg),
                           '_',tolower(params$datatype),'_wtd.RData'))
            argus_recoded_wtd <- loadRData_noalloc(paste0(params$val_dir,'/SAS_Datasets/',
                                                          tolower(params$bigseg),'_',
                                                          tolower(params$datatype),'_wtd.RData'))
          }
        }
        names(argus_recoded_wtd) <- tolower(names(argus_recoded_wtd))
      } else if (!exists('argus_recoded_wtd')) {
        message(paste0('\n  Loading ',params$datapath,'/argus_20b.RData'))
        argus_recoded_wtd <- loadRData(paste0(params$datapath,'/argus_20b.RData'),
                                       params$colalloc)
      }
      main_23(params,argus_recoded_wtd)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
      # message('\n  Running NBI_SalesEffectAnalysis_Report.Rmd')
      # message(paste0('  - Writing ',params$outputpath,
      #                '/NBI_SalesEffectAnalysis_Report.html'))
      # Sys.setenv(RSTUDIO_PANDOC="C:/Program Files/RStudio/bin/pandoc")
      # render(paste0(params$code_loc,"/NBI_SalesEffectAnalysis_Report.Rmd"),#'all',
      #        output_dir = params$outputpath,params = list(path = params$path),
      #        quiet = T)
    }
    if (params$mod_41$run) {
      message('\n####################### Running 41StatSigTesting... ############################\n')
      source(paste0(params$code_loc,"/41StatSigTesting.R"))
      #source(paste0(params$code_loc,"/41StatSigTesting3_non_financial_test.R"))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      if(params$use_sas_input) {
        if (params$val_format == 'sas7bdat') {
          message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',
                         tolower(params$bigseg),'_',tolower(params$datatype),'_wtd.sas7bdat'))
          argus_recoded_wtd <- as.data.table(haven::read_sas(paste0(params$val_dir,
                               '/SAS_Datasets/',tolower(params$bigseg),'_',
                               tolower(params$datatype),'_wtd_complete.sas7bdat')))
        } else if (params$val_format == 'RData') {
          if (params$path == 'E:/McDonalds') {
            message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',tolower(params$bigseg),
                           '_',tolower(params$datatype),'_wtd_complete.RData'))
            argus_recoded_wtd <- loadRData_noalloc(paste0(params$val_dir,'/SAS_Datasets/',
                                                          tolower(params$bigseg),'_',
                                                          tolower(params$datatype),
                                                          '_wtd_complete.RData'))
          } else {
            message(paste0('  Loading ',params$val_dir,'/SAS_Datasets/',tolower(params$bigseg),
                           '_',tolower(params$datatype),'_wtd.RData'))
            argus_recoded_wtd <- loadRData_noalloc(paste0(params$val_dir,'/SAS_Datasets/',
                                                          tolower(params$bigseg),'_',
                                                          tolower(params$datatype),'_wtd.RData'))
          }
        }
        names(argus_recoded_wtd) <- tolower(names(argus_recoded_wtd))
      } else if (!exists('argus_recoded_wtd')) {
        message(paste0('\n  Loading ',params$datapath,'/argus_20b.RData'))
        argus_recoded_wtd <- loadRData(paste0(params$datapath,'/argus_20b.RData'),
                                       params$colalloc)
      }
      params <<- params
      argus_recoded_wtd <<- argus_recoded_wtd
      main_41(params,argus_recoded_wtd)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
    }
    if (exists('argus_recoded_wtd')) {
      rm(argus_recoded_wtd)
      foo <- gc()
    }
    if ((params$mod_50$run) & (params$NMCoutput)) {
      message('\n####################### Running 50TransposeforNMC... ###########################\n')
      source(paste0(params$code_loc,"/50 Transpose for NMC.R"))
      startmod <- Sys.time()
      message(paste0('  Starting at: ', format(startmod, '%d/%b/%y %H:%M:%S')))
      main_50(params)
      endmod <- Sys.time()
      message(paste0('\n  Finished at: ', format(endmod, '%d/%b/%y %H:%M:%S')))
      message(paste0('  Module took: ', format(endmod-startmod)))
      rm(list = setdiff(ls(),to_keep))
      foo <- gc()
    }
    
    message('\n##################### FINISHED SALES EFFECT ANALYSIS ###########################\n')
    endjob <- Sys.time()
    message(paste0('  Finished at: ', format(endjob, '%d/%b/%y %H:%M:%S')))
    message(paste0('  Job took: ', format(endjob-startjob)))
    
    sink()
    closeAllConnections()
  }
  
}
################################################################################
############################## Run Main Function ###############################
################################################################################
if (getOption('run.main', default=TRUE)) {
  
  path <- 'E:/eBay'
  params <- fromJSON(file.path(path,'params.json'), simplifyDataFrame=TRUE)
  main_10(params)
  
}
